#include "Contact.h"
#include "Function.h"
#include "EMailAddress.h"
#include "MailAddress.h"
#include "IMAddress.h"
#include "WebAddress.h"
#include "TelephoneNumber.h"
#include "AddressBook.h"

Contact::~Contact () {
  _addressBook->removeContact(this);
}

Function* Contact::createFunction() {
  Function *function=new Function(this);
  _functions.push_back(function);
  return function; 
}

void Contact::removeFunction(Function *function) {
  _functions.remove(function);
}

EMailAddress* Contact::createEMailAddress() {
  EMailAddress *address=new EMailAddress(this);
  _addresses.push_back(address);
  return address; 
}

IMAddress* Contact::createIMAddress() {
  IMAddress *address=new IMAddress(this);
  _addresses.push_back(address);
  return address; 
}

MailAddress* Contact::createMailAddress() {
  MailAddress *address=new MailAddress(this);
  _addresses.push_back(address);
  return address; 
}

TelephoneNumber* Contact::createTelephoneNumber() {
  TelephoneNumber *address=new TelephoneNumber(this);
  _addresses.push_back(address);
  return address; 
}

WebAddress* Contact::createWebAddress() {
  WebAddress *address=new WebAddress(this);
  _addresses.push_back(address);
  return address; 
}

void Contact::removeAddress(Address *address) {
  _addresses.remove(address);
}

